```
<
# preprocess a T2 dicom to raw png, and saved in "./media/convert_img/T2"
def preprocessing(file_path,file_name):
    dicom = pydicom.read_file(file_path)
    try:
        pixel = dicom.pixel_array
    except:
        image = sitk.ReadImage(file_path)
        image_array = sitk.GetArrayFromImage(image)
        pixel = np.int16(image_array)

    # window_center = dicom.get('WindowCenter')
    # window_width = dicom.get('WindowWidth')
    #
    # pixel[pixel > window_center + window_width / 2] = window_center + window_width / 2
    # pixel[pixel < window_center - window_width / 2] = window_center - window_width / 2

    #pixel=np.array(pixel, dtype=np.uint8)
    # pixel=np.array(pixel,dtype=np.float32)

    pixel = 255 * ((pixel - np.amin(pixel)) / (np.amax(pixel) - np.amin(pixel)))

    pixel = np.array(pixel, dtype=np.uint8)
    if len(pixel.shape)==3:
        pixel=pixel[0]
    image = Image.fromarray(pixel).convert('L')
    save_path = os.path.join("./media/convert_img/T2", file_name.replace('dcm','png'))
    image.save(os.path.join(save_path))
    return save_path
    

# process a raw ADC dicom and save a ADC png in './media/output/'
def read_adc_prostate(ADC_path):
    ADC_dicom = pydicom.dcmread(ADC_path)
    try:
        ADC_array = ADC_dicom.pixel_array
    except:
        image = sitk.ReadImage(ADC_path)
        image_array = sitk.GetArrayFromImage(image)
        ADC_array = np.int16(image_array)

    ADC_array = 255 * ((ADC_array - np.amin(ADC_array)) / (np.amax(ADC_array) - np.amin(ADC_array)))

    if len(ADC_array.shape)==3:
        ADC_array=ADC_array[0]

    save_path = './media/output/'
    Image.fromarray(ADC_array).convert('L').save(save_path + 'adc.png')
    return

# process a raw BVAL dicom and save a BVAL png in './media/output/'
def read_bval_prostate(BVAL_path):
    BVAL_dicom = pydicom.dcmread(BVAL_path)
    try:
        BVAL_array = BVAL_dicom.pixel_array
    except:
        image = sitk.ReadImage(BVAL_path)
        image_array = sitk.GetArrayFromImage(image)
        BVAL_array = np.int16(image_array)

    BVAL_array = 255 * ((BVAL_array - np.amin(BVAL_array)) / (np.amax(BVAL_array) - np.amin(BVAL_array)))

    if len(BVAL_array.shape)==3:
        BVAL_array=BVAL_array[0]

    save_path = './media/output/'
    Image.fromarray(BVAL_array).convert('L').save(save_path + 'bval.png')
    return

# process a ADC png, and save its contour, prostate region in './media/output/'
def adc_transform(ADC_path,T2_path,x1_T2,y1_T2,x2_T2,y2_T2):

    y1_inraw = int(y1_T2)
    x1_inraw = int(x1_T2)
    y2_inraw = int(y2_T2)
    x2_inraw = int(x2_T2)

    T2_dicom = pydicom.dcmread(T2_path)

    ImageOrientationPatient = T2_dicom.ImageOrientationPatient
    ImagePositionPatient = T2_dicom.ImagePositionPatient
    PixelSpacing = T2_dicom.PixelSpacing

    a = np.array([[ImageOrientationPatient[0] * PixelSpacing[0],
                   ImageOrientationPatient[3] * PixelSpacing[1],
                   ImagePositionPatient[0]],
                  [ImageOrientationPatient[1] * PixelSpacing[0],
                   ImageOrientationPatient[4] * PixelSpacing[1],
                   ImagePositionPatient[1]],
                  [ImageOrientationPatient[2] * PixelSpacing[0],
                   ImageOrientationPatient[5] * PixelSpacing[1],
                   ImagePositionPatient[2]]
                  ])

    threeD_x1y1 = np.dot(a, (np.array([x1_inraw, y1_inraw, 1])))
    threeD_x1y2 = np.dot(a, (np.array([x1_inraw, y2_inraw, 1])))
    threeD_x2y1 = np.dot(a, (np.array([x2_inraw, y1_inraw, 1])))
    threeD_x2y2 = np.dot(a, (np.array([x2_inraw, y2_inraw, 1])))

    ADC_dicom = pydicom.dcmread(ADC_path)

    ImageOrientationPatient = ADC_dicom.ImageOrientationPatient
    ImagePositionPatient = ADC_dicom.ImagePositionPatient
    PixelSpacing = ADC_dicom.PixelSpacing

    a_adc = np.array([[ImageOrientationPatient[0] * PixelSpacing[0],
                       ImageOrientationPatient[3] * PixelSpacing[1],
                       ImagePositionPatient[0]],
                      [ImageOrientationPatient[1] * PixelSpacing[0],
                       ImageOrientationPatient[4] * PixelSpacing[1],
                       ImagePositionPatient[1]],
                      [ImageOrientationPatient[2] * PixelSpacing[0],
                       ImageOrientationPatient[5] * PixelSpacing[1],
                       ImagePositionPatient[2]]
                      ])

    result_x1y1 = np.linalg.solve(a_adc, threeD_x1y1)
    result_x1y1_x = result_x1y1[0]
    result_x1y1_y = result_x1y1[1]

    result_x1y2 = np.linalg.solve(a_adc, threeD_x1y2)
    result_x1y2_x = result_x1y2[0]
    result_x1y2_y = result_x1y2[1]

    result_x2y1 = np.linalg.solve(a_adc, threeD_x2y1)
    result_x2y1_x = result_x2y1[0]
    result_x2y1_y = result_x2y1[1]

    result_x2y2 = np.linalg.solve(a_adc, threeD_x2y2)
    result_x2y2_x = result_x2y2[0]
    result_x2y2_y = result_x2y2[1]

    x1_raw_ADC = int(min(result_x1y1_x, result_x1y2_x, result_x2y1_x, result_x2y2_x))
    x2_raw_ADC = int(max(result_x1y1_x, result_x1y2_x, result_x2y1_x, result_x2y2_x))
    y1_raw_ADC = int(min(result_x1y1_y, result_x1y2_y, result_x2y1_y, result_x2y2_y))
    y2_raw_ADC = int(max(result_x1y1_y, result_x1y2_y, result_x2y1_y, result_x2y2_y))

    try:
        ADC_array = ADC_dicom.pixel_array
    except:
        image = sitk.ReadImage(ADC_path)
        image_array = sitk.GetArrayFromImage(image)
        ADC_array = np.int16(image_array)

    ADC_array = 255 * ((ADC_array - np.amin(ADC_array)) / (np.amax(ADC_array) - np.amin(ADC_array)))

    if len(ADC_array.shape)==3:
        ADC_array=ADC_array[0]
    try:
        if y2_raw_ADC - y1_raw_ADC < 50:
            y1_raw_ADC = int(y1_raw_ADC - (50 - (y2_raw_ADC - y1_raw_ADC)) / 2)
            y2_raw_ADC = int(y2_raw_ADC + (50 - (y2_raw_ADC - y1_raw_ADC)) / 2)
        if x2_raw_ADC - x1_raw_ADC < 50:
            x1_raw_ADC = int(x1_raw_ADC - (50 - (x2_raw_ADC - x1_raw_ADC)) / 2)
            x2_raw_ADC = int(x2_raw_ADC + (50 - (x2_raw_ADC - x1_raw_ADC)) / 2)

        crop_img = ADC_array[y1_raw_ADC:y2_raw_ADC, x1_raw_ADC:x2_raw_ADC]

        save_path = './media/output/'
        Image.fromarray(ADC_array).convert('L').save(save_path+'adc.png')
        Image.fromarray(crop_img).convert('L').resize((224,224)).save(save_path+'adc_crop.png')

        im=Image.fromarray(ADC_array).convert('RGB')

        draw=ImageDraw.Draw(im)
        draw.rectangle((x1_raw_ADC,y1_raw_ADC,x2_raw_ADC,y2_raw_ADC),outline=(255,255,0),width=3)
        im.save(save_path+'adc_contour.png')
    except:
        print('ADC error!')
    return

# process a BVAL png, and save its contour, prostate region in './media/output/'
def bval_transform(bval_path,T2_path,x1_T2,y1_T2,x2_T2,y2_T2):
    y1_inraw = int(y1_T2)
    x1_inraw = int(x1_T2)
    y2_inraw = int(y2_T2)
    x2_inraw = int(x2_T2)

    T2_dicom = pydicom.dcmread(T2_path)

    ImageOrientationPatient = T2_dicom.ImageOrientationPatient
    ImagePositionPatient = T2_dicom.ImagePositionPatient
    PixelSpacing = T2_dicom.PixelSpacing

    a = np.array([[ImageOrientationPatient[0] * PixelSpacing[0],
                   ImageOrientationPatient[3] * PixelSpacing[1],
                   ImagePositionPatient[0]],
                  [ImageOrientationPatient[1] * PixelSpacing[0],
                   ImageOrientationPatient[4] * PixelSpacing[1],
                   ImagePositionPatient[1]],
                  [ImageOrientationPatient[2] * PixelSpacing[0],
                   ImageOrientationPatient[5] * PixelSpacing[1],
                   ImagePositionPatient[2]]
                  ])

    threeD_x1y1 = np.dot(a, (np.array([x1_inraw, y1_inraw, 1])))
    threeD_x1y2 = np.dot(a, (np.array([x1_inraw, y2_inraw, 1])))
    threeD_x2y1 = np.dot(a, (np.array([x2_inraw, y1_inraw, 1])))
    threeD_x2y2 = np.dot(a, (np.array([x2_inraw, y2_inraw, 1])))

    bval_dicom = pydicom.dcmread(bval_path)

    ImageOrientationPatient = bval_dicom.ImageOrientationPatient
    ImagePositionPatient = bval_dicom.ImagePositionPatient
    PixelSpacing = bval_dicom.PixelSpacing

    a_bval = np.array([[ImageOrientationPatient[0] * PixelSpacing[0],
                       ImageOrientationPatient[3] * PixelSpacing[1],
                       ImagePositionPatient[0]],
                      [ImageOrientationPatient[1] * PixelSpacing[0],
                       ImageOrientationPatient[4] * PixelSpacing[1],
                       ImagePositionPatient[1]],
                      [ImageOrientationPatient[2] * PixelSpacing[0],
                       ImageOrientationPatient[5] * PixelSpacing[1],
                       ImagePositionPatient[2]]
                      ])

    result_x1y1 = np.linalg.solve(a_bval, threeD_x1y1)
    result_x1y1_x = result_x1y1[0]
    result_x1y1_y = result_x1y1[1]

    result_x1y2 = np.linalg.solve(a_bval, threeD_x1y2)
    result_x1y2_x = result_x1y2[0]
    result_x1y2_y = result_x1y2[1]

    result_x2y1 = np.linalg.solve(a_bval, threeD_x2y1)
    result_x2y1_x = result_x2y1[0]
    result_x2y1_y = result_x2y1[1]

    result_x2y2 = np.linalg.solve(a_bval, threeD_x2y2)
    result_x2y2_x = result_x2y2[0]
    result_x2y2_y = result_x2y2[1]

    x1_raw_bval = int(min(result_x1y1_x, result_x1y2_x, result_x2y1_x, result_x2y2_x))
    x2_raw_bval = int(max(result_x1y1_x, result_x1y2_x, result_x2y1_x, result_x2y2_x))
    y1_raw_bval = int(min(result_x1y1_y, result_x1y2_y, result_x2y1_y, result_x2y2_y))
    y2_raw_bval = int(max(result_x1y1_y, result_x1y2_y, result_x2y1_y, result_x2y2_y))

    try:
        bval_array = bval_dicom.pixel_array
    except:
        image = sitk.ReadImage(bval_path)
        image_array = sitk.GetArrayFromImage(image)
        bval_array = np.int16(image_array)

    bval_array = 255 * ((bval_array - np.amin(bval_array)) / (np.amax(bval_array) - np.amin(bval_array)))

    if len(bval_array.shape)==3:
        bval_array=bval_array[0]
    try:
        if y2_raw_bval - y1_raw_bval < 50:
            y1_raw_bval = int(y1_raw_bval - (50 - (y2_raw_bval - y1_raw_bval)) / 2)
            y2_raw_bval = int(y2_raw_bval + (50 - (y2_raw_bval - y1_raw_bval)) / 2)
        if x2_raw_bval - x1_raw_bval < 50:
            x1_raw_bval = int(x1_raw_bval - (50 - (x2_raw_bval - x1_raw_bval)) / 2)
            x2_raw_bval = int(x2_raw_bval + (50 - (x2_raw_bval - x1_raw_bval)) / 2)
        crop_img = bval_array[y1_raw_bval:y2_raw_bval, x1_raw_bval:x2_raw_bval]
        save_path = './media/output/'
        Image.fromarray(bval_array).convert('L').save(save_path + 'bval.png')
        Image.fromarray(crop_img).convert('L').resize((224,224)).save(save_path + 'bval_crop.png')

        im = Image.fromarray(bval_array).convert('RGB')

        draw = ImageDraw.Draw(im)
        draw.rectangle((x1_raw_bval, y1_raw_bval, x2_raw_bval, y2_raw_bval), outline=(255, 255, 0), width=3)
        im.save(save_path + 'bval_contour.png')
    except:
        print('bval error!')
    return

>
```